Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 5238)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 5239)
@@ -441,9 +441,10 @@
       }
     }
-    private void RebuildImageList() {
+    protected virtual void RebuildImageList() {
       itemsListView.SmallImageList.Images.Clear();
-      foreach (ListViewItem item in itemsListView.Items) {
-        itemsListView.SmallImageList.Images.Add(((T)item.Tag).ItemImage);
-        item.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
+      foreach (ListViewItem listViewItem in itemsListView.Items) {
+        T item = listViewItem.Tag as T;
+        itemsListView.SmallImageList.Images.Add(item == null ? HeuristicLab.Common.Resources.VS2008ImageLibrary.Nothing : item.ItemImage);
+        listViewItem.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
       }
     }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 5238)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 5239)
@@ -379,9 +379,10 @@
       }
     }
-    private void RebuildImageList() {
+    protected virtual void RebuildImageList() {
       itemsListView.SmallImageList.Images.Clear();
-      foreach (ListViewItem item in itemsListView.Items) {
-        itemsListView.SmallImageList.Images.Add(((T)item.Tag).ItemImage);
-        item.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
+      foreach (ListViewItem listViewItem in itemsListView.Items) {
+        T item = listViewItem.Tag as T;
+        itemsListView.SmallImageList.Images.Add(item == null ? HeuristicLab.Common.Resources.VS2008ImageLibrary.Nothing : item.ItemImage);
+        listViewItem.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
       }
     }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 5238)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 5239)
@@ -458,9 +458,10 @@
       }
     }
-    private void RebuildImageList() {
+    protected virtual void RebuildImageList() {
       itemsListView.SmallImageList.Images.Clear();
-      foreach (ListViewItem item in itemsListView.Items) {
-        itemsListView.SmallImageList.Images.Add(((T)item.Tag).ItemImage);
-        item.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
+      foreach (ListViewItem listViewItem in itemsListView.Items) {
+        T item = listViewItem.Tag as T;
+        itemsListView.SmallImageList.Images.Add(item == null ? HeuristicLab.Common.Resources.VS2008ImageLibrary.Nothing : item.ItemImage);
+        listViewItem.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
       }
     }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 5238)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 5239)
@@ -430,7 +430,8 @@
     private void RebuildImageList() {
       itemsListView.SmallImageList.Images.Clear();
-      foreach (ListViewItem item in itemsListView.Items) {
-        itemsListView.SmallImageList.Images.Add(((IRun)item.Tag).ItemImage);
-        item.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
+      foreach (ListViewItem listViewItem in itemsListView.Items) {
+        IRun item = listViewItem.Tag as IRun;
+        itemsListView.SmallImageList.Images.Add(item == null ? HeuristicLab.Common.Resources.VS2008ImageLibrary.Nothing : item.ItemImage);
+        listViewItem.ImageIndex = itemsListView.SmallImageList.Images.Count - 1;
       }
     }