Index: /branches/OKBJavaConnector/HLOKBWebClient/src/main/java/at/hl/okb/IECJConnector.java
===================================================================
--- /branches/OKBJavaConnector/HLOKBWebClient/src/main/java/at/hl/okb/IECJConnector.java	(revision 5246)
+++ /branches/OKBJavaConnector/HLOKBWebClient/src/main/java/at/hl/okb/IECJConnector.java	(revision 5247)
@@ -3,6 +3,4 @@
 import java.util.List;
 import java.util.Map;
-
-import at.hl.wsclient.okb.AlgorithmParameter;
 
 /**
@@ -22,6 +20,6 @@
 	 * @throws Exception
 	 */
-	public Map<String,AlgorithmParameter> initializeAlgorithm(String algorithmName, String algorithmClassId,
-		    String platformId, Iterable<String> algorithmParameterName) throws Exception;
+//	public Map<String,AlgorithmParameter> initializeAlgorithm(String algorithmName, String algorithmClassId,
+//		    String platformId, Iterable<String> algorithmParameterName) throws Exception;
 	
 	/**
@@ -38,5 +36,5 @@
 	 * @throws Exception
 	 */
-	public void initialize(String algorithm, String platform, String problem, Map<String, Object> algoParams, Map<String,Object> problemParams, Object paramFile) throws Exception;
+	public void initialize(String algorithm, String platform, String problem) throws Exception; //, Map<String, Object> algoParams, Map<String,Object> problemParams, Object paramFile) throws Exception;
 
 	/**
@@ -45,4 +43,5 @@
 	 * @throws Exception
 	 */
-	public void result(List<Object> resultList) throws Exception;
+	public void result(List<Object> resultList, Map<String, Object> algoParams, Map<String, Object> problemParams,
+			Object paramFile) throws Exception;
 }
Index: /branches/OKBJavaConnector/HLOKBWebClient/src/main/java/at/hl/okb/impl/ECJ19ConnectorImpl.java
===================================================================
--- /branches/OKBJavaConnector/HLOKBWebClient/src/main/java/at/hl/okb/impl/ECJ19ConnectorImpl.java	(revision 5246)
+++ /branches/OKBJavaConnector/HLOKBWebClient/src/main/java/at/hl/okb/impl/ECJ19ConnectorImpl.java	(revision 5247)
@@ -10,4 +10,5 @@
 import at.hl.okb.wsclient.OKBClientTest;
 import at.hl.okb.wsclient.OKBServiceClient;
+import at.hl.wsclient.okb.Algorithm;
 import at.hl.wsclient.okb.AlgorithmParameter;
 
@@ -33,22 +34,21 @@
 	 * java.lang.String, java.util.Map, java.util.Map, java.lang.Object)
 	 */
-	public void initialize(String algorithm, String platform, String problem,
-			Map<String, Object> algoParams, Map<String, Object> problemParams,
-			Object paramFile) throws Exception {
+	@Override
+	public void initialize(String algorithmName, String platformName, String problemName) throws Exception {
 		// TODO Auto-generated method stub
 
-		Long platformId = okbClient.getPlatformId(platform);
+		Long platformId = okbClient.getPlatformId(algorithmName);
 		if (platformId == null)
-			throw new Exception("Platform " + platform + " not found!");
+			throw new Exception("Platform " + algorithmName + " not found!");
 
-		Long algorithmId = okbClient.getAlgorithmId(algorithm);
+		Long algorithmId = okbClient.getAlgorithmId(algorithmName, platformId);
 		if (algorithmId == null)
-			throw new Exception("Algorithm " + algorithm + " not found!");
+			throw new Exception("Algorithm " + algorithmName + " for Platform" + platformName + " not found!");
 
-		Long problemId = okbClient.getProblemId(problem);
+		Long problemId = okbClient.getProblemId(problemName);
 		if (problemId == null)
-			throw new Exception("Proble " + problem + " not found!");
+			throw new Exception("Proble " + problemName + " not found!");
 
-		okbClient.checkAlgoParamsExists(algorithmId, algoParams);
+		//okbClient.checkAlgoParamsExists(algorithmId, algoParams);
 		// check problemParams(problemParams)
 
@@ -64,27 +64,36 @@
 	 * @see at.hl.okb.IECJConnector#result(java.util.List)
 	 */
-	public void result(List<Object> resultList) throws Exception {
+	@Override
+	public void result(List<Object> resultList, Map<String, Object> algoParams, Map<String, Object> problemParams,
+			Object paramFile) throws Exception {
 		// TODO Auto-generated method stub
-
+		
+		//create Experiment if algoparams empty and problemparams empty (in HL)
+		//create missing Params in Algo and Problem (if not exits for experiment)
+		//create Datatype if missing
+		
 	}
 
-	@Override
-	public Map<String, AlgorithmParameter> initializeAlgorithm(
-			String algorithmName, String algorithmClassName, String platformName,
-			Iterable<String> algorithmParameterName) throws Exception {
-		
-		/*Long platformId = okbClient.getPlatformId(platformName);
-		if (platformId==null)
-			throw new Exception("Platform " + platformName + " not found!");		
-		
-		okbClient.getAlgorithm(algorithmName, Long.valueOf(algorithmClassId), platformId)
-		
-		if (okbClient.getAlgorithmClassId(algorithmName)==null)
-			throw new Exception("Algorithm " + algorithmName + " not found in HL!");
-		
-		
-			*/
-		return null;
-		
-	}
+//	@Override
+//	public Map<String, AlgorithmParameter> initializeAlgorithm(
+//			String algorithmName, String algorithmClassName, String platformName,
+//			Iterable<String> algorithmParameterName) throws Exception {
+//		
+//		Long platformId = okbClient.getPlatformId(platformName);
+//		if (platformId==null)
+//			throw new Exception("Platform " + platformName + " not found in HL!");		
+//
+////		Long algorithmClassId = okbClient.getAlgorithmClassId(algorithmClassName);
+////		if (algorithmClassId==null)
+////			throw new Exception("AlgorithmClass " + platformName + " not found in HL!");		
+//		
+//		Long algorithmId = okbClient.getAlgorithmId(algorithmName, /*algorithmClassId*/ platformId);
+//		if (algorithmId==null)
+//			throw new Exception("Algorithm " + algorithmName + " not found in HL!");
+//
+//		
+//
+//		return null;
+//		
+//	}
 }